=== actions/CMakeLists.txt ===
add_custom_target(actions ALL)
add_subdirectory(doc)
add_subdirectory(tests)

pm_action_init()
pm_action(pm-build-model actions)
pm_action(pm-build-rawmodel actions)
pm_action(pm-help actions)
pm_action(pm-build-sidechains actions)
