=== extras/CMakeLists.txt ===
# put bash completion in place
# - care for stage directory (etc/bash_completion.d)
# - 'compile' bash completion for pm
# - install

# bash completion file(s)
set(_BC_FILE pm-completion.bash)

# handling bash completion
set(_BC_DIR "${ETC_STAGE_PATH}/bash_completion.d")
set(_ETC_BC_FILE "${_BC_DIR}/${_BC_FILE}")
set(_BC_SUBST_DICT -DINPUT_FILE=${CMAKE_CURRENT_SOURCE_DIR}/${_BC_FILE}.in -DOUT_FILE=${_ETC_BC_FILE} -DPM3_ACTION_NAMES=${PM3_ACTION_NAMES})
add_custom_command(OUTPUT ${_ETC_BC_FILE}
                   MAIN_DEPENDENCY "${CMAKE_SOURCE_DIR}/CMakeLists.txt"
                   DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/${_BC_FILE}.in"
                   COMMAND ${CMAKE_COMMAND} ${_BC_SUBST_DICT}
                   -P ${CMAKE_SOURCE_DIR}/cmake_support/substitute.cmake)
add_custom_target(bash-completion ALL DEPENDS ${_ETC_BC_FILE})
