=== loop/CMakeLists.txt ===
add_subdirectory(src)
add_subdirectory(pymod)
add_subdirectory(data)
add_subdirectory(tests)
add_subdirectory(doc)
