=== scripts/CMakeLists.txt ===
set(SUBST_DICT OST_ROOT="${OST_ROOT}"
               LIBDIR=${LIB_DIR}
               LIBEXECPATH=${LIBEXEC_PATH}
               PYTHON_MODULE_PATH=${PYTHON_MODULE_PATH}
               OST_PYMOD_PATH=${OST_PYMOD_PATH}
               Python_EXECUTABLE=${Python_EXECUTABLE})

add_custom_target(promod3_scripts ALL)

set(PROMOD3_SCRIPTS pm)

script(NAME pm INPUT pm.in SUBSTITUTE ${SUBST_DICT} 
       TARGET promod3_scripts)

copy_if_different("${CMAKE_CURRENT_BINARY_DIR}" "${STAGE_DIR}/bin"
                  "${PROMOD3_SCRIPTS}" "promod3_scripts" promod3_scripts)

set(_PROMOD3_BUILD_SCRIPTS)
foreach(_pm3_script PROMOD3_SCRIPTS)
  list(APPEND _PROMOD3_BUILD_SCRIPTS ${_pm3_script})
endforeach()

add_dependencies(codetest promod3_scripts)

install(FILES ${PROMOD3_BUILD_SCRIPTS} DESTINATION "bin/")
