=== actions/doc/CMakeLists.txt ===
set(ACTION_RST
index.rst
index_dev.rst
)

add_doc_source(NAME actions RST ${ACTION_RST})
