=== actions/tests/CMakeLists.txt ===
set(ACTION_UNIT_TESTS
  test_action_build-model.py
  test_action_build-rawmodel.py
  test_action_help.py
  test_actions.py # leave this as last item so it will be executed first!
)

set(ACTION_TEST_DATA
  data/gly.pdb
  data/seq.fasta
  data/seq_ins.fasta
)

promod3_unittest(MODULE actions
  SOURCES "${ACTION_UNIT_TESTS}"
  DATA "${ACTION_TEST_DATA}"
  TARGET actions
)

if(NOT DISABLE_DOCUMENTATION)
  add_doc_dependency(NAME actions
                     DEP "${CMAKE_CURRENT_SOURCE_DIR}/test_actions.py")
endif()
