=== cmake_support/doc/CMakeLists.txt ===
set(CMAKE_RST
index.rst
)

add_doc_source(NAME cmake RST ${CMAKE_RST})
