=== config/src/CMakeLists.txt ===
# if we need more than one configurational header, add path in front of every
# file via loop!
set(CONFIG_HH_FILE "config.hh")

configure_file(config.hh.in ${CONFIG_HH_FILE})

add_custom_target(config_header)
copy_if_different("${CMAKE_CURRENT_BINARY_DIR}" "${HEADER_STAGE_PATH}/promod3"
                  "${CONFIG_HH_FILE}" "config_headers" config_header)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${CONFIG_HH_FILE} DESTINATION "include/promod3/")
