=== core/init/CMakeLists.txt ===
# for translation of __init__.py
set(_CRE_INIT_SUBST_DICT OST_COMPOUNDS_CHEMLIB_PATH="${OST_COMPOUNDS_CHEMLIB_PATH}"
                         OST_ROOT=${OST_ROOT}
                         PROMOD3_VERSION_STRING=${PROMOD3_VERSION_STRING}
                         GIT_BRANCH=${GIT_BRANCH}
                         GIT_COMMIT_HASH=${GIT_COMMIT_HASH})

# top level PM3 init.py (Python only)
pymod(NAME init PY __init__.py TRANSLATE ${_CRE_INIT_SUBST_DICT} END_TRANSLATE
      OUTPUT_DIR "promod3" DEPENDS_ON _core _sidechain _loop _scoring _modelling)
