=== core/pymod/CMakeLists.txt ===
# core module
set(CORE_CPP
  export_geom.cc
  export_runtime_profiling.cc
  export_graph_minimizer.cc
  wrap_core.cc
)

set(CORE_PYMOD
  __init__.py
  helper.py
  pm3argparse.py
)

pymod(NAME core CPP ${CORE_CPP} PY ${CORE_PYMOD})
