=== debian/changelog ===
promod3 (3.6.0+ds-1) unstable; urgency=medium

  * Upload to unstable.

 -- Andrius Merkys <merkys@debian.org>  Thu, 16 Oct 2025 02:50:26 -0400

promod3 (3.6.0+ds-1~exp) experimental; urgency=medium

  * New upstream release 3.6.0+ds.

 -- Andrius Merkys <merkys@debian.org>  Tue, 14 Oct 2025 04:39:50 -0400

promod3 (3.5.0+ds-1~exp) experimental; urgency=medium

  * New upstream release 3.5.0+ds.

 -- Andrius Merkys <merkys@debian.org>  Mon, 26 May 2025 03:50:37 -0400
