=== debian/control ===
Source: promod3
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-python,
 libboost-filesystem-dev,
 libboost-iostreams-dev,
 libboost-program-options-dev,
 libboost-python-dev,
 libboost-test-dev,
 libeigen3-dev,
 libost-base-dev,
 libost-conop-dev,
 libost-geom-dev,
 libost-img-dev,
 libost-info-dev,
 libost-io-dev,
 libost-mol-alg-dev,
 libost-mol-dev,
 libost-mol-mm-dev,
 libost-seq-alg-dev,
 libost-seq-dev,
 libsqlite3-dev,
 openstructure (>= 2.5.0),
 python3-dev,
 python3-ost,
Standards-Version: 4.5.1
Homepage: https://openstructure.org/promod3/
Vcs-Browser: https://salsa.debian.org/debichem-team/promod3
Vcs-Git: https://salsa.debian.org/debichem-team/promod3.git
Rules-Requires-Root: no

Package: libpromod3-core-dev
Section: libdevel
Architecture: any
Depends:
 libpromod3-core3.6 (= ${binary:Version}),
 ${misc:Depends},
Description: protein homology modelling engine
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains development files for ProMod3 core.

Package: libpromod3-core3.6
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: protein homology modelling engine
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains the shared library for ProMod3 core.

Package: libpromod3-loop-dev
Section: libdevel
Architecture: any
Depends:
 libpromod3-loop3.6 (= ${binary:Version}),
 ${misc:Depends},
Description: protein homology modelling engine
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains development files for loop handling engine.

Package: libpromod3-loop3.6
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: protein homology modelling engine
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains the shared library for loop handling engine.

Package: libpromod3-modelling-dev
Section: libdevel
Architecture: any
Depends:
 libpromod3-modelling3.6 (= ${binary:Version}),
 ${misc:Depends},
Description: protein homology modelling engine
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains development files for modelling engine.

Package: libpromod3-modelling3.6
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: protein homology modelling engine
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains the shared library for modelling engine.

Package: libpromod3-scoring-dev
Section: libdevel
Architecture: any
Depends:
 libpromod3-scoring3.6 (= ${binary:Version}),
 ${misc:Depends},
Description: protein homology modelling engine
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains development files for scoring functions.

Package: libpromod3-scoring3.6
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: protein homology modelling engine
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains the shared library for scoring functions.

Package: libpromod3-sidechain-dev
Section: libdevel
Architecture: any
Depends:
 libpromod3-sidechain3.6 (= ${binary:Version}),
 ${misc:Depends},
Description: protein homology modelling engine
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains development files for sidechain handling.

Package: libpromod3-sidechain3.6
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: protein homology modelling engine
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains the shared library for sidechain handling.

Package: promod3
Architecture: all
Depends:
 python3,
 python3-ost,
 python3-promod3,
 ${python3:Depends},
 ${misc:Depends},
Description: protein homology modelling engine
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.

Package: promod3-data
Architecture: all
Depends:
 ${misc:Depends},
Description: protein homology modelling engine - data files
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains ProMod3 data files.

Package: python3-promod3
Architecture: any
Section: python
Depends:
 openstructure,
 promod3-data,
 python3-ost,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
X-Python3-Version: ${python3:Versions}
Description: protein homology modelling engine - Python 3 package
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains ProMod3 Python 3 package.
