=== debian/watch ===
version=4
opts=searchmode=plain,uversionmangle=s/-/~/g,repack,repacksuffix=+ds,dversionmangle=auto \
https://git.scicore.unibas.ch/schwede/ProMod3/-/tags \
 /schwede/ProMod3/-/archive/[^/]+/ProMod3-@ANY_VERSION@@ARCHIVE_EXT@
